# Copyright (c) Microsoft Corporation. 
# Licensed under the MIT license. 

import math
import os
import sys
import glob
import gc
import threading

from pathlib import Path
from simplygon import simplygon_loader
from simplygon import Simplygon


def RunRemeshing(sg: Simplygon.ISimplygon):
    sgSceneImporter = sg.CreateSceneImporter()
    sgSceneImporter.SetImportFilePath( "../Assets/ObscuredTeapot/ObscuredTeapot.obj" )
    if not sgSceneImporter.RunImport():
        raise Exception("Failed to load ObscuredTeapot/ObscuredTeapot.obj.")
    sgScene = sgSceneImporter.GetScene()

    # Create the remeshing pipeline. 
    sgRemeshingPipeline = sg.CreateRemeshingPipeline()

    sgRemeshingSettings = sgRemeshingPipeline.GetRemeshingSettings()

    # Add a selection set to the scene with all nodes which should be remeshed. 
    sgSceneSelectionSetTable = sgScene.GetSelectionSetTable()
    sgRemeshingTargetSelectionSet = sg.CreateSelectionSet()
    sgRemeshingTargetSelectionSet.SetName("RemeshingTarget")
    sgRootTeapot001 = sgScene.GetNodeFromPath("Root/Teapot001")
    if sgRootTeapot001 is not None:
        sgRemeshingTargetSelectionSet.AddItem(sgRootTeapot001.GetNodeGUID())
    sgSceneSelectionSetTable.AddSelectionSet(sgRemeshingTargetSelectionSet)

    # Set on-screen size target for remeshing. 
    sgRemeshingSettings.SetOnScreenSize( 300 )

    # Use the selection set created earlier. 
    sgRemeshingSettings.SetProcessSelectionSetName( "RemeshingTarget" )

    # Start the remeshing pipeline. 
    sgRemeshingPipeline.RunScene(sgScene, Simplygon.EPipelineRunMode_RunInThisProcess)

    # Get the processed scene. 
    sgProcessedScene = sgRemeshingPipeline.GetProcessedScene()

    sgSceneExporter = sg.CreateSceneExporter()
    sgSceneExporter.SetScene(sgProcessedScene)
    sgSceneExporter.SetExportFilePath( "RemeshingOutput.fbx" )
    if not sgSceneExporter.RunExport():
        raise Exception("Failed to save RemeshingOutput.fbx.")


if __name__ == '__main__':
    sg = simplygon_loader.init_simplygon()

    RunRemeshing(sg)

    sg = None
    gc.collect()

